package Dop;

import java.awt.*;

public class DopClassTriangle implements IDop{
    public int numOfWheels;

    public DopClassTriangle(int num){
        numOfWheels = num;
    }
    public void setNumOfWheels(String num){
        switch (Integer.valueOf(num)){
            case 2:
                numOfWheels = NumberOfWheelsEnum.wheel_2.value;
                break;
            case 3:
                numOfWheels = NumberOfWheelsEnum.wheel_3.value;
                break;
            case 4:
                numOfWheels = NumberOfWheelsEnum.wheel_4.value;
                break;
            default:
                numOfWheels = NumberOfWheelsEnum.wheel_2.value;
        }

    }

    public void drawWheels(Graphics g, int _startPosX, int _startPosY, Color c) {
        g.setColor(c);

        if (numOfWheels >= 2) {
            g.fillPolygon(new int[]{_startPosX, _startPosX + 15/2, _startPosX + 15}, new int[]{_startPosY + 35 + 10, _startPosY + 35 + 10 + 15/2, _startPosY + 35 + 10}, 3);
            g.fillPolygon( new int[]{_startPosX + 95, _startPosX + 95 + 15/2, _startPosX + 95 + 15}, new int[]{_startPosY + 35 + 10, _startPosY + 35 + 10 + 15/2, _startPosY + 35 + 10}, 3);
        } if (numOfWheels >= 3) {
            g.fillPolygon(new int[]{_startPosX + 15, _startPosX + 15 + 15/2, _startPosX + 15 + 15}, new int[]{_startPosY + 35 + 10, _startPosY + 35 + 10 + 15/2, _startPosY + 35 + 10}, 3);
        } if (numOfWheels >= 4) {
            g.fillPolygon(new int[]{_startPosX + 95 - 20, _startPosX + 95 - 20 + 15/2, _startPosX + 95 - 20 + 15}, new int[]{_startPosY + 35 + 10, _startPosY + 35 + 10 + 15/2, _startPosY + 35 + 10}, 3);
        }
    }
}

