package DrawingObjects;



import Dop.*;
import Entities.*;

import java.awt.*;
import java.util.Random;

public class DrawingDumpTruck extends DrawingCar{
    EntityDumpTruck EntityCar;


    public DrawingDumpTruck(int speed, double weight, Color bodyColor, Color additionalColor, boolean bodyKit, boolean tent,  boolean ornamentWheels, int width, int height) {
        super(speed, weight, bodyColor, width, height, 110, 60);
        {
                EntityCar = new EntityDumpTruck(speed, weight, bodyColor, additionalColor, bodyKit, tent);
        }
    }
    public DrawingDumpTruck(EntityDumpTruck entityDumpTruck,IDop wheels)
    {
        super(entityDumpTruck, wheels);
        {
            EntityCar = entityDumpTruck;
            this.wheels = wheels;
        }
    }


    public EntityDumpTruck getEntityDumpTruck(){
        return EntityCar;
    }

    public void DrawTransport(Graphics g)
    {
        EntityDumpTruck dumpTruck;
        if (EntityCar == null )
        {
            return;
        }


        Color addBrush = EntityCar.AdditionalColor;
        Color brush = EntityCar.BodyColor;

        super.DrawTransport(g);
        if (EntityCar.Tent)
        {
            g.setColor(addBrush);
            int[] pointsX = new int[3];
            int[] pointsY = new int[3];
            pointsX[0] = _startPosX; pointsY[0] = _startPosY + 35;
            pointsX[1] = _startPosX + 85; pointsY[1] = _startPosY;
            pointsX[2] = _startPosX + 85; pointsY[2] = _startPosY + 35;
            g.fillPolygon(pointsX, pointsY, 3);

        }

        if (EntityCar.BodyKit)
        {
            g.setColor(addBrush);
            int[] pointsX = new int[4];
            int[] pointsY = new int[4];
            pointsX[0] = _startPosX; pointsY[0] = _startPosY + 35;
            pointsX[1] = _startPosX; pointsY[1] = _startPosY;
            pointsX[2] = _startPosX + 85; pointsY[2] = _startPosY;
            pointsX[3] = _startPosX + 85; pointsY[3] = _startPosY + 35;
            g.fillPolygon(pointsX, pointsY, 4);
        }

        if (EntityCar.BodyKit && EntityCar.Tent)
        {
            g.setColor(brush);
            int x = _startPosX;
            int y = _startPosY - 8;
            g.fillRect(_startPosX, _startPosY, 95, 3);

        }

        if (wheels == null){return;}
        wheels.drawWheels(g, _startPosX, _startPosY, brush);
    }
}
